package com.sample.android.file_data_read1;

import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

import android.app.Activity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.EditText;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.Toast;

public class File_Data_Read1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
	private LinearLayout layout;

	private EditText Get_FileName;  //ファイル名の表示//
    private EditText FileNameIn_Edit;
    private EditText Data_Show_Edit;
    private Button   Read_Data_Button; //読み込みボタン
    private Button   Read_FileName_Button; //読み込みボタン
    
    private FileInputStream file_input_stream;
    private InputStreamReader input_stream_reader;
    private BufferedReader buffer_reader;
    private StringBuffer string_buffer = null;

    private String gyo = null;

    @Override
    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this); //
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);//中央寄せ
        setContentView(layout);

        Get_FileName = new EditText(this);
        Get_FileName.setText("保存されているファイルの一覧\n");
        Get_FileName.setTextSize(20);
        layout.addView(Get_FileName, new LinearLayout.LayoutParams(WC, WC));
        
        //読み込みボタンの生成
        Read_FileName_Button = new Button(this);
        Read_FileName_Button.setTextColor(Color.RED);
        Read_FileName_Button.setTextSize(20);
        Read_FileName_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Read_FileName_Button.setText("Read_File_Name");
        Read_FileName_Button.setOnClickListener(this);
        layout.addView(Read_FileName_Button, new LinearLayout.LayoutParams(WC, WC));
        
        //ファイル名の入力用のエディットテキストの生成
        FileNameIn_Edit = new EditText(this);
        FileNameIn_Edit.setText("ファイル名の入力",EditText.BufferType.NORMAL);
        layout.addView(FileNameIn_Edit, new LinearLayout.LayoutParams(MP, WC));

        //データの入力用のエディットテキストの生成
        Data_Show_Edit = new EditText(this);
        Data_Show_Edit.setText("データの表示領域",EditText.BufferType.NORMAL);
        layout.addView(Data_Show_Edit, new LinearLayout.LayoutParams(MP, WC));

        //読み込みボタンの生成
        Read_Data_Button = new Button(this);
        Read_Data_Button.setTextColor(Color.RED);
        Read_Data_Button.setTextSize(20);
        Read_Data_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Read_Data_Button.setText("Read_Data");
        Read_Data_Button.setOnClickListener(this);
        layout.addView(Read_Data_Button, new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
    	if(v == Read_FileName_Button)
    	{
    	   Read_File_Name();
    	}else if(v == Read_Data_Button)
    	{
    		Read_File_Data();
    	}
    }

    private void Read_File_Data()
    {
    	try {
    	     file_input_stream = openFileInput(FileNameIn_Edit.getText().toString());
    	     input_stream_reader = new InputStreamReader(file_input_stream);  //入力ストリームの生成
    	     buffer_reader = new BufferedReader(input_stream_reader);  //バッファリングの設定

    	     string_buffer = new StringBuffer();  //文字列バッファを作成する

    	     while ((gyo = buffer_reader.readLine()) != null)  //文字列を1行ずつ読み込む！
    	     {
    	    	 string_buffer.append(gyo); //読み込んだ行を「string_buffer」に追加する
    	    	 string_buffer.append("\n");  //改行コードの追加
    	    	 //string_buffer.append(System.getProperty("line.separator"));  //「行セパレータ文字」を取得して、追加する！
    	     }

    	     buffer_reader.close();
    	     Toast.makeText(getApplicationContext(), "データを読み込みました！",Toast.LENGTH_SHORT).show();
    	}
    	catch (IOException e)
    	{
    		Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
    	}

    	Data_Show_Edit.setText(string_buffer.toString());  //string_bufferの内容をEditTextに表示する
    }
    
    private void Read_File_Name()
    {
    	String file_name[] = fileList();  //ファイル名のリストを取得する
    	
    	string_buffer = new StringBuffer();
    	
    	for(int i = 0; i < file_name.length; i++)
    	{
    		string_buffer.append(file_name[i]);
    		string_buffer.append(System.getProperty("line.separator"));
    	}
    	Get_FileName.setText(string_buffer.toString());
    }
}