package com.sample.android.file_data_write1;

import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.BufferedWriter;
import java.io.IOException;

import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Button;
import android.content.Context;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.Toast;

public class File_Data_Write1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
	private LinearLayout layout;

    private EditText FileNameIn_Edit;  //EditText
    private EditText DataIn_Edit;  //EditText
    private Button   Write_Button;  //書き込みボタン

    private FileOutputStream fife_output_stram;
    private OutputStreamWriter out_straem_writer;
    private BufferedWriter buffer_writer;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);//中央寄せ
        setContentView(layout);

        //ファイル名の入力用のEditTextの生成
        FileNameIn_Edit = new EditText(this);
        FileNameIn_Edit.setText("ファイル名の入力",EditText.BufferType.NORMAL);
        layout.addView(FileNameIn_Edit, new LinearLayout.LayoutParams(MP, WC));

        //データの入力用のEditTextの生成
        DataIn_Edit = new EditText(this);
        DataIn_Edit.setText("データの入力",EditText.BufferType.NORMAL);
        layout.addView(DataIn_Edit, new LinearLayout.LayoutParams(MP, WC));

        //書き込みボタンの生成
        Write_Button = new Button(this);
        Write_Button.setTextColor(Color.RED);
        Write_Button.setTextSize(30);
        Write_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Write_Button.setText("Write");
        Write_Button.setOnClickListener(this);
        layout.addView(Write_Button, new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
    	Data_Write();
    }

    private void Data_Write()
    {
    	try
    	{
    	   //ファイル名を取得し、モードを設定する
    	   fife_output_stram = openFileOutput(FileNameIn_Edit.getText().toString(),Context.MODE_PRIVATE | Context.MODE_APPEND);

    	   out_straem_writer = new OutputStreamWriter(fife_output_stram);  //出力ストリームの生成
    	   buffer_writer = new BufferedWriter(out_straem_writer);  //バッファリング(Buffering)の設定

    	   buffer_writer.write(DataIn_Edit.getText().toString());  //バッファにためる！
    	   buffer_writer.flush();  //バッファのデータをファイルに書き込む
    	   buffer_writer.close(); //出力ストリームのクローズ
    	   Toast.makeText(getApplicationContext(), "データを書き込みました！",Toast.LENGTH_SHORT).show();
    	} catch (IOException e)
    	{
    		showDialog(this,"エラー","データの書き込みに失敗しました！ ");
    		Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
    	}
    }

	private void showDialog(File_Data_Write1 file_Data_Write1, String string,String string2) {
		// TODO 自動生成されたメソッド・スタブ
	}
}