package com.sample.android.fragment_3_test1;

import android.app.Activity;
import android.os.Bundle;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.view.View;
import android.view.ViewGroup;
import android.view.LayoutInflater;


public class Fragment_3_Test1 extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        Fragment_1 frag1 = new Fragment_1();  //Fragment用のオブジェクトの取得
        Fragment_2 frag2 = new Fragment_2();
        Fragment_3 frag3 = new Fragment_3();
        
        //新しいFragmentの生成のためのTranzaction用のオブジェクトを取得
        FragmentTransaction fragment_tsaction = getFragmentManager().beginTransaction();

        //ViewにあるFragment(R.id.fragment1)を、生成したFragment(frag1)で入れ替える
        fragment_tsaction.replace(R.id.fragment1, frag1);
        fragment_tsaction.replace(R.id.fragment2, frag2);
        fragment_tsaction.replace(R.id.fragment3, frag3);

        fragment_tsaction.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE); //フェードをかける
        fragment_tsaction.commit();   //結果を反映させる
    }
    
    /** フラグメントを生成するときに呼ばれるクラス */
    public static class Fragment_1 extends Fragment
    {
    	@Override
    	public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState)
    	{
    	    return inflater.inflate(R.layout.fragment1, container, false);
    	}
    }
    
    public static class Fragment_2 extends Fragment
    {
    	@Override
    	public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState)
    	{
    	    return inflater.inflate(R.layout.fragment2, container, false);
    	}
    }
    
    public static class Fragment_3 extends Fragment
    { 	
    	@Override
    	public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState)
    	{
    	    return inflater.inflate(R.layout.fragment3, container, false);
    	}
    }
}