package com.sample.android.http_test1;
import java.net.*;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;

import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

public class Http_Test1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
	private LinearLayout layout;

    private TextView show_TextView1; //テキストビュー
    private Button   button1; //Startボタン

    private URL url_obj;
    private HttpURLConnection http_con; //HttpURLConnectionクラスのオブジェクトの取得
    private InputStream in_stream;

    private final static String URL1 = "http://www.yahoo.co.jp";

    private byte in_data[];
    
    private Handler  handler = new Handler();
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);
       
        button1 = new Button(this);   //Startボタンの生成
        button1.setTextColor(Color.RED);
        button1.setTextSize(20);
        button1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button1.setText("Start");
        button1.setOnClickListener(this);
        layout.addView(button1, new LinearLayout.LayoutParams(WC, WC));
       
        show_TextView1 = new EditText(this);   //データの表示用のTextViewの生成
        show_TextView1.setTextColor(Color.RED);
        show_TextView1.setTextSize(20);
        show_TextView1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        show_TextView1.setText("データの表示領域",EditText.BufferType.NORMAL);
        layout.addView(show_TextView1, new LinearLayout.LayoutParams(MP, WC));
    }

    public void onClick(View v)
    {
        if (v == button1)
        {
            //スレッドの生成
            Thread thread1 = new Thread(new Runnable(){ public void run()
            {

               try{
                     url_obj = new URL(URL1);  //HTTP接続のオープン

                     //HttpURLConnectionクラスのオブジェクトの取得
                     http_con = (HttpURLConnection)url_obj.openConnection();

                     http_con.setRequestMethod("GET");  //ダウンロード
                     http_con.connect();  //接続

                     in_stream = http_con.getInputStream();  //入力Streamの取得
                     in_data = new byte[1024];
                     in_stream.read(in_data);  //バイト配列へのデータの読み込み

                     //HTTP接続のクローズ
                     in_stream.close();
                     http_con.disconnect();
                  }catch(Exception e)
                  {
            	     show_TextView1.setText(e.toString());  //エラー
            	     Toast.makeText(Http_Test1.this, e.toString(),Toast.LENGTH_LONG).show();
                  }
            
                  //データの受け取り用のハンドラの生成
                  handler.post(new Runnable(){public void run()
                 {
                     if(in_data !=null)  //受け取るデータがあるか？
                     {
                         show_TextView1.setText(new String(in_data)); //HTML データの表示！
                         Toast.makeText(getApplicationContext(), URL1 ,Toast.LENGTH_SHORT).show();
                     }else{
                    	 show_TextView1.setText("エラー：：データの読み込み失敗しました! ");
                         Toast.makeText(getApplicationContext(), URL1 ,Toast.LENGTH_SHORT).show();
                     }
                  }});
           }});

           thread1.start();
        }
    }
}