package com.sample.android.intent_test2;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.Toast;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.content.Intent;
import android.net.Uri;

public class Intent_Test2 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;

	private TextView text1;
	private EditText edit1;

	private TextView text2;
	private EditText edit2;

	private Button   button; //送信ボタン

	private Intent intent1;
	private String action1;
	private String uri1;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);

        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);//中央寄せ
        setContentView(layout);

        text1 = new TextView(this);  //Action の入力用
        text1.setTextColor(Color.RED);
        text1.setTextSize(20);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("[ Action ] の入力：");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        edit1 = new EditText(this);
        layout.addView(edit1, new LinearLayout.LayoutParams(MP, WC));

        text2 = new TextView(this);  //URI の入力用
        text2.setTextColor(Color.GREEN);
        text2.setTextSize(20);
        text2.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text2.setText("[ URI ] の入力：");
        layout.addView(text2, new LinearLayout.LayoutParams(WC, WC));

        edit2 = new EditText(this);
        layout.addView(edit2, new LinearLayout.LayoutParams(MP, WC));
        
        button = new Button(this);  //ボタンの生成
        button.setTextColor(Color.RED);
        button.setTextSize(20);
        button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button.setText("送信");
        button.setOnClickListener(this);
        layout.addView(button, new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        if (v == button)
        {
    		action1 = edit1.getText().toString();
    		uri1    = edit2.getText().toString();

        	try
        	{
        		intent1 = new Intent(action1, Uri.parse(uri1));
        		//intent1 = new Intent(Intent.ACTION_DIAL, Uri.parse(uri1));
        		startActivity(intent1);

        	}catch(Exception e)
            {
        		Toast.makeText(getApplicationContext(), "エラーが発生しました！",Toast.LENGTH_SHORT).show();
        		text1.setText(e.toString());
            }
        }
    }
}