package com.sample.android.message_broadcast1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.Toast;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.content.Intent;

public class Message_Broadcast1 extends Activity implements OnClickListener{
    /** Called when the activity is first created. */

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private final int FP = ViewGroup.LayoutParams.FILL_PARENT;

	private LinearLayout layout;

	private TextView text1;
	private EditText edit1;
	private Button   button;

	private Intent intent1;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.RED);
        text1.setTextSize(20);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("送信メッセージの入力：");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        edit1 = new EditText(this);
        layout.addView(edit1, new LinearLayout.LayoutParams(FP, WC));
        
        button = new Button(this);  //ボタンの生成
        button.setTextColor(Color.RED);
        button.setTextSize(18);
        button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button.setText("[ Message_Receiver1 ] の呼び出し");
        button.setOnClickListener(this);
        button.setGravity(Gravity.CENTER);
        layout.addView(button, new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        if (v == button)
        {
        	try
        	{
        		//EditTextに入力したデータの取得
                String edit1_message = edit1.getText().toString();

                //暗黙的なインテントの生成 (String action)
                intent1 = new Intent("com.sample.android.message_broadcast1.SHOW_MESSAGE");

                //Intentへのパラメータの付加 (String key, String value)
                intent1.putExtra("send_message1", edit1_message);
                
                sendBroadcast(intent1);  //intent の Broadcast

        	}catch(Exception e)
            {
        		Toast.makeText(getApplicationContext(), "送信エラーが発生しました！",Toast.LENGTH_SHORT).show();
            }
        }
    }
}