package com.sample.android.nfc_test1;

import android.app.Activity;
import android.os.Bundle;
import android.nfc.NfcAdapter;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.content.Intent;
import android.widget.TextView;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.Toast;

public class NFC_Test1 extends Activity {
    /** Called when the activity is first created. */

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private LinearLayout layout;

	private Intent intent;

	private TextView textview1;
	private String str_id = "";


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.main);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setBackgroundColor(Color.rgb(0,0,255));  //背景「黒」
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        textview1 = new TextView(this);
        textview1.setTextColor(Color.WHITE);  //文字の色「白」
        textview1.setTextSize(20);
        textview1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        textview1.setText("Tag_IDの表示");
        layout.addView(textview1, new LinearLayout.LayoutParams(WC, WC));

        //NfcAdapterのインスタンスを取得
        NfcAdapter nfc_adapter =  NfcAdapter.getDefaultAdapter();

        // NFCが有効か否かを確認
        if( nfc_adapter.isEnabled() ){
        	Toast.makeText(getApplicationContext(), "NFC は 有効です！",Toast.LENGTH_SHORT).show();
        }else{
        	Toast.makeText(getApplicationContext(), "NFC は 無効です！",Toast.LENGTH_SHORT).show();
        }

        intent = getIntent();

        String intent_action = intent.getAction();  //アクション名を取得

        if(intent_action.equals( NfcAdapter.ACTION_TAG_DISCOVERED) )
        {
           byte[] id_buffer = intent.getByteArrayExtra(NfcAdapter.EXTRA_ID);

           for( int i = 0 ; i < id_buffer.length ; i++ )
           {
               str_id += Integer.toHexString(id_buffer [i]);  //+ "\n"
           }

           textview1.setText(str_id);
        }

    }
}