package com.sample.android.news_listfragment_main2;

import android.app.Activity;
import android.os.Bundle;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.app.ListFragment;
import android.content.Intent;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.TextView;

public class News_ListFragment_Main2 extends Activity {
	private static final String[] LIST_MENU_ITEMS = { "今日の天気", "今日のサッカー", "今日の野球" , "今日の株価" };

	private static final String[] MENU_CONTENT  =  {
        "北海道は曇り、東京はおおむね晴れ、沖縄は台風の接近に注意が必要です。",
        "日本対ウズベキスタン戦は「8 : 0」で日本が大勝しました。",
        "オールスターゲームが仙台で開かれ、パシフィックリーグが「10 : 0」で大勝しました。",
        "ギリシャの債務問題を懸念して世界中の株価が下落しました。" };

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.fragment_layout);
    }

    public static class News_ListMenu_Fragment extends ListFragment
    {
        boolean two_PaneLayout;
        int selected_Position = 0;

        @Override
        public void onActivityCreated(Bundle savedInstanceState)
        {
            super.onActivityCreated(savedInstanceState);

            //リスト・メニューの作成
   		    setListAdapter(new ArrayAdapter<String>(getActivity(), android.R.layout.simple_list_item_checked, LIST_MENU_ITEMS));

   		    getListView().setChoiceMode(ListView.CHOICE_MODE_SINGLE);  //ListMenuを単一選択モードに設定
            getListView().setBackgroundColor(Color.BLUE);  //ListMenuの背景色
            getListView().setScrollingCacheEnabled(false);  //ListMenuのスクロル 背景が描画されないことはなくなる

            //ニュースの内容を表示するためのFrameのViewオブジェクトを取得
            View news_content_Frame = getActivity().findViewById(R.id.news_details);

            //縦画面のときは「R.id.news_details」はない！
            two_PaneLayout = news_content_Frame != null && news_content_Frame.getVisibility() == View.VISIBLE;

            if(savedInstanceState != null)
            {
                selected_Position = savedInstanceState.getInt("selectedPosition", 0);  //選択されたメニュー項目の保存
            }

            if(two_PaneLayout) //デュアルモードのとき
            {
                disp_News_Conten(selected_Position);  //ニュースの内容を表示する自作の関数
            }
        }

        @Override
        public void onSaveInstanceState(Bundle outState)  //Menuの選択された状態の保持
        {
            super.onSaveInstanceState(outState);
            outState.putInt("selectedPosition", selected_Position);
        }

        @Override
        public void onListItemClick(ListView l, View v, int position, long id)
        {
            disp_News_Conten(position);  //ニュースの内容を表示する自作の関数
        }

        void disp_News_Conten(int index)
        {
        	selected_Position = index;

            if(two_PaneLayout)  //横画面のとき
            {
                News_Content_Fragment news_fragment = (News_Content_Fragment)getFragmentManager().findFragmentById(R.id.news_details);

                if(news_fragment == null || news_fragment.getShownIndex() != index)
                {
                    news_fragment = News_Content_Fragment.newInstance(index);  //ニュースの「内容の表示用のFragmentの生成

                    FragmentTransaction fragment_transaction = getFragmentManager().beginTransaction();

                    //トランザクションを開始して既存のフラグメントと入れ替える
                    fragment_transaction.replace(R.id.news_details, news_fragment);
                    fragment_transaction.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);  //フェードをかける

                    fragment_transaction.addToBackStack(null);//操作の状態をStackに保存！  前の画面tへ 戻るのに必要
                    fragment_transaction.commit();  //Tranzactionを有効にする
                }

            } else {
            	 //縦画面のとき
                Intent intent = new Intent();

                intent.setClass(getActivity(), Portrait_Activity2.class);  //縦向き(ポートレイト)の「内容」画面用のActivity
                intent.putExtra("index", index);

                startActivity(intent);  //ニュースの「内容」を表示する縦画面のActivityを呼ぶ
            }
        }
    }

    public static class News_Content_Fragment extends Fragment
    {
        public static News_Content_Fragment newInstance(int index)
        {
            News_Content_Fragment news_fragment = new News_Content_Fragment();

            //選択されたメニューに対応するインデックスを設定
            Bundle arguments = new Bundle();

            arguments.putInt("index", index);  //intentに渡す選択されたindex
            news_fragment.setArguments(arguments);

            return news_fragment;  //生成したFragmentを返す
        }

        public int getShownIndex()  //設定した配列のindexを取得
        {
            return getArguments().getInt("index", 0);
        }

        @Override
        public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
        {
            if(container == null)  //container が無いレイアウトなので、view は生成しない
            {
                return null;
            }
            container.setBackgroundColor(Color.YELLOW);  //ニュースの画面の背景色

            TextView text_view = new TextView(getActivity());  //ニュースの内容を表示するためのTextView

            text_view.setText(MENU_CONTENT[getArguments().getInt("index", 0)] );  //ニュースの内容を表示
            text_view.setTextColor (Color.BLACK);
            text_view.setTextSize(24);

            return text_view;
        }
    }
}