package com.sample.android.news_listfragment_main2;

import android.app.Activity;
import android.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import android.content.res.Configuration;
import android.graphics.Color;

public  class Portrait_Activity2 extends Activity
{
    	private static final String[] MENU_CONTENT  =  {
            "北海道は曇り、東京はおおむね晴れ、沖縄は台風の接近に注意が必要です。",
            "日本対ウズベキスタン戦は「8 : 0」で日本が大勝しました。",
            "オールスターゲームが仙台で開かれ、パシフィックリーグが「10 : 0」で大勝しました。",
            "ギリシャの債務問題を懸念して世界中の株価が下落しました。" };

        @Override
        protected void onCreate(Bundle savedInstanceState)
        {
            super.onCreate(savedInstanceState);

            //横画面のとき、元のActivityに戻る
            if(getResources().getConfiguration().orientation == Configuration.ORIENTATION_LANDSCAPE)
            {
                finish();
                return;
            }

            if (savedInstanceState == null)
            {
                //内容画面のフラグメントを生成
                News_Content_Fragment news_fragment = new News_Content_Fragment();

                news_fragment.setArguments(getIntent().getExtras());  //Intentで送られたデータの取得

                //内容画面のFragmentを加えるTranzactionを実行
                getFragmentManager().beginTransaction().add(android.R.id.content, news_fragment).commit();
            }
        }

        public static class News_Content_Fragment extends Fragment
        {
            public static News_Content_Fragment newInstance(int index)
            {
                News_Content_Fragment news_fragment = new News_Content_Fragment();

                Bundle arguments = new Bundle();

                arguments.putInt("index", index);  //intentに渡す選択されたメニューの配列のindexを設定
                news_fragment.setArguments(arguments);

                return news_fragment;  //生成したFragmentを返す
            }

            public int getShownIndex()
            {
                return getArguments().getInt("index", 0); //選択されたメニューの配列のindexを取得
            }

            @Override
            public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
            {
                if(container == null)
                {
                    return null;  //表示するcontainerがないとき
                }

                container.setBackgroundColor(Color.YELLOW);  //ニュースの内容画面の背景色

                TextView text_view = new TextView(getActivity());  //ニュースの内容を表示するためのTextView

                text_view.setText(MENU_CONTENT[getArguments().getInt("index", 0)] );  //ニュースの内容を表示
                text_view.setTextColor (Color.BLACK);
                text_view.setTextSize(24);

                return text_view;
            }
        }
}