package com.sample.android.preference1;

import android.app.Activity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Button;
import android.widget.TextView;
import android.graphics.Color;
import android.graphics.Typeface;
import android.content.SharedPreferences;
import android.widget.LinearLayout;
import android.widget.Toast;

public class Preference1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
	public static final String FILENAME = "Preference1";
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
    
	private LinearLayout layout;

    private EditText keyIn_Edit1;  //Key入力用
    private EditText valueIn_Edit1;  //Value入力用
    
    private EditText keyIn_Edit2;  //表示用のKey入力用
    private TextView value_show_TextView;  //Value表示用
    
    private Button   write_Button;  //書き込みボタン
    private Button   read_Button;  //読み込みボタン
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);//中央寄せ
        setContentView(layout);

        //Keyの入力用のエディットテキストの生成
        keyIn_Edit1 = new EditText(this);
        keyIn_Edit1.setText("書き込む「Key」の入力",EditText.BufferType.NORMAL);
        layout.addView(keyIn_Edit1, new LinearLayout.LayoutParams(MP, WC));

        //Valueの入力用のエディットテキストの生成
        valueIn_Edit1 = new EditText(this);
        valueIn_Edit1.setText("書き込む「Value」の入力",EditText.BufferType.NORMAL);
        layout.addView(valueIn_Edit1, new LinearLayout.LayoutParams(MP, WC));

        //書き込みボタンの生成
        write_Button = new Button(this);
        write_Button.setTextColor(Color.RED);
        write_Button.setTextSize(30);
        write_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        write_Button.setText("Write");
        write_Button.setOnClickListener(this);//(2)
        layout.addView(write_Button, new LinearLayout.LayoutParams(WC, WC));
        
         //読み込みボタンの生成
        read_Button = new Button(this);
        read_Button.setTextColor(Color.BLUE);
        read_Button.setTextSize(30);
        read_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        read_Button.setText("Read");
        read_Button.setOnClickListener(this);//(2)
        layout.addView(read_Button, new LinearLayout.LayoutParams(WC, WC));
        
        //Keyの入力用のエディットテキストの生成
        keyIn_Edit2 = new EditText(this);
        keyIn_Edit2.setText("読み込む「Key」の入力",EditText.BufferType.NORMAL);
        layout.addView(keyIn_Edit2, new LinearLayout.LayoutParams(MP, WC));

        //Valueの表示用のテキストビューの生成
        value_show_TextView = new EditText(this);
        value_show_TextView.setTextColor(Color.RED);
        value_show_TextView.setTextSize(20);
        value_show_TextView.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        value_show_TextView.setText("「Value」の表示領域",EditText.BufferType.NORMAL);
        layout.addView(value_show_TextView, new LinearLayout.LayoutParams(MP, WC));
    }
    
    public void onClick(View v)
    {
        if (v == write_Button)
        {
        	String get_key = keyIn_Edit1.getText().toString();  //Key入力値の取得
        	
        	String get_value = valueIn_Edit1.getText().toString();  //Value入力値の取得
        	
        	//SharedPreferencesオブジェクトの取得
        	SharedPreferences preference = getSharedPreferences(FILENAME, MODE_PRIVATE);
        	
        	//プリファレンスへの書き込み
        	SharedPreferences.Editor editor = preference.edit();  //SharedPreferences.Editorオブジェクトの取得
        	editor.putString(get_key, get_value);
        	editor.commit();
        	
        	keyIn_Edit1.setText("");
        	valueIn_Edit1.setText("");
        	
        	Toast.makeText(getApplicationContext(), "データを書き込みました！",Toast.LENGTH_SHORT).show();
        }else if (v == read_Button)
        {
        	String get_key = keyIn_Edit2.getText().toString();
        	
        	//SharedPreferencesオブジェクトの取得
        	SharedPreferences preference = getSharedPreferences(FILENAME, MODE_PRIVATE);
        	
        	 //プリファレンスからの値の読み込み
        	value_show_TextView.setText("Keyに対する値 : " + preference.getString(get_key, "Keyに対する値なし！"));
        	
        	Toast.makeText(getApplicationContext(), "データを読み込みました！",Toast.LENGTH_SHORT).show();
        }
    }
}