package com.sample.android.puzzle_game1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

public class Puzzle_Game1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

    private final static int WC=TableLayout.LayoutParams.WRAP_CONTENT;

    private TextView text1;
    private Button button[] = new Button[16];
    private Button start_button;

    private int no = -1;
    private int sw = -1; //
    private boolean flag = false;
    private int vacant = 0;  //「空白」部分の位置(インデックス)
    private int indx1 = 0;  //クリックしたパネルの「インデックス」（「0～15」)
    private int i, j;
    
    private int panel[] = new int[16];  //「1～16」の乱数の格納
    private int ch[] = new int[17];     //「1～16」の乱数の格納
    static int bakcol[] = new int[16];  //パネルの背景色用の配列

    @Override  //パネルの色と数値の初期設定
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //TableLayoutの生成
        TableLayout tb_layout = new TableLayout(this);
        tb_layout.setBackgroundColor(Color.BLACK);
        tb_layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(tb_layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.WHITE);
        text1.setTextSize(40);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD));
        text1.setText("パズルゲーム ！");
        tb_layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        bakcol[0] = Color.rgb(0,0,255);
        bakcol[1] = Color.rgb(0,255,0);
        bakcol[2] = Color.rgb(0,255,255);
        bakcol[3] = Color.rgb(255,0,0);
        bakcol[4] = Color.rgb(255,0,255);
        bakcol[5] = Color.rgb(255,255,0);
        bakcol[6] = Color.rgb(255,255,255);
        bakcol[7] = Color.rgb(0,128,255);
        bakcol[8] = Color.rgb(128,255,200);
        bakcol[9] = Color.rgb(200,255,200);
        bakcol[10] = Color.rgb(255,128,128);
        bakcol[11] = Color.rgb(100,128,100);
        bakcol[12] = Color.rgb(255,255,128);
        bakcol[13] = Color.rgb(128,128,128);
        bakcol[14] = Color.rgb(255,100,50);
        bakcol[15] = Color.rgb(0,255,128);

        for (int i = 0 ; i < 4 ;i++)
        {
            //行の要素
            TableRow row = new TableRow(this);
            row.setLayoutParams(new TableLayout.LayoutParams(WC,WC));
            row.setGravity(Gravity.CENTER);  //表示す数値の中央寄せ
            tb_layout.addView(row);

            //列の要素
            for (int j = 0 ; j < 4 ; j++)
            {
            	no++;
                button[no] = new Button(this);
                button[no].setText( "" + no  );
                button[no].setTextColor(Color.BLACK);
                button[no].setBackgroundColor(bakcol[no]);
                button[no].setWidth(75);
                button[no].setHeight(75);
                button[no].setTextSize(35);
                button[no].setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
                button[no].setId(no);
                button[no].setOnClickListener(this);
                row.addView(button[no]);
            }
        }

        start_button = new Button(this);
        start_button.setText("Start");
        start_button.setTextColor(Color.RED);
        start_button.setTextSize(35);
        start_button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        start_button.setOnClickListener(this);
        tb_layout.addView(start_button, new LinearLayout.LayoutParams(WC, WC));
    }

    //Startボタンとパネルのクリックイベント処理
    public void onClick(View view)
    {
        if(start_button == view)
        {
            flag = true;

            for (i = 0; i < 16; i++)
            {
                ch[i] = 0;
                ch[16] = 0;  //「0」クリア
            }

            //同じ番号のパネルの重複がないかをチェック
            for (i = 0; i < 16; i++)	//乱数の発生「1～15」
            {
                do
                {
                    j = (int)(16 * Math.random() + 1);  //乱数の発生「1～15」
                } while (ch[j] != 0);	//同じ数値の重複チェック

                ch[j] = 1;

                button[i].setText("" + j);
                panel[i] = j;  //「1～16」の乱数の格納

                if (panel[i] == 16)  //乱数「16」のところを「空白」表示にする
                {
                	button[i].setText("");
                    vacant = i;	//「空白」部分の位置(インデックス「0～15」)
                }
            }
        }

        int n = view.getId();  //クリックしたパネル(Button)の「ID」を取得

        switch (n) //クリックしたパネルの判定
        {
            case 0:
                indx1 = 0;  //「パネル１」
                Panel_Click();	//クリックしたパネルが移動可能かを判定するメソッド
                break;

            case 1:
                indx1 = 1;
                Panel_Click();
                break;

            case 2:
                indx1 = 2;
                Panel_Click();
                break;

            case 3:
                indx1 = 3;
                Panel_Click();
                break;

            case 4:
                indx1 = 4;
                Panel_Click();
                break;

            case 5:
                indx1 = 5;
                Panel_Click();
                break;

            case 6:
                indx1 = 6;
                Panel_Click();
                break;

            case 7:
                indx1 = 7;
                Panel_Click();
                break;

            case 8:
                indx1 = 8;
                Panel_Click();
                break;

            case 9:
                indx1 = 9;
                Panel_Click();
                break;

            case 10:
                indx1 = 10;
                Panel_Click();
                break;

            case 11:
                indx1 = 11;
                Panel_Click();
                break;

            case 12:
                indx1 = 12;
                Panel_Click();
                break;

            case 13:
                indx1 = 13;
                Panel_Click();
                break;

            case 14:
                indx1 = 14;
                Panel_Click();
                break;

            case 15:
                indx1 = 15;
                Panel_Click();
                break;

            default:
                sw = -1;
        }
    }

    //パネルをクリックしたとき、パネルの移動が可能かの判定
    public void Panel_Click()
    {
        int i, exout;

        exout = 1;  //上がりの判定用

        if (indx1 == vacant + 4)  //「空白パネル」の下の「数字パネル」をクリック
            Move_Panel();
        else if (indx1 == vacant - 4)  //「空白パネル」の上の「数字パネル」をクリック
            Move_Panel();
        else if ((indx1 == vacant - 1) && ( (vacant % 4 ) != 0))
            //「空白パネル」の左の「数字パネル」をクリック(「空白パネル」が左端)
            Move_Panel();
        else if ((indx1 == vacant + 1) && ( (vacant % 4 ) != 3))
            //「空白パネル」の右の「数字パネル」をクリック(「空白パネル」が右端)
            Move_Panel();

        for (i = 0; i < 15; i++)
        {
            if (panel[i] != i + 1)
            {
                exout = 0;  //数値が不連続のときに「0」をセット
                break;      //ループを抜ける！
            }
        }

        //「上がり」のチェック
        if (exout == 0)  //数値が不連続のとき
        {
            exout = 1;
        }
        else    //数値が連続しているとき
        {
        	text1.setTextSize(25);
        	text1.setText("おめでとう 上がりです！");
        }
    }

    //交換が可能なとき、隣り合う「パネル」を交換する
    public void Move_Panel()
    {
        panel[vacant] = panel[indx1];  //「空白パネル」に「数値パネル」をセット

        button[vacant].setText("" + panel[vacant]);

        button[indx1].setText("");  //前の「数字パネル」をクリア
        vacant = indx1;  //新しい「空白パネル」
    }
}