package com.sample.amdroid.sqlite_test3;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.Cursor;
import android.content.ContentValues;
import android.content.Context;
import android.content.ContentProvider;
import android.net.Uri;
import android.widget.Toast;

//DBを提供するコンテントプロバイダ
public class SQLite_ContentProvider1 extends ContentProvider{
	
	private final static int DATABASE_VERSION  = 1;
	private final static String DATABASE_NAME = "test1.db";   //データベース名
	private final static String DATABASE_TABLE = "data_table1";   //テーブル名
	private final static String DATABASE_COLUMN = "column1";   //カラム名
	
	//データベースオブジェクトの取得
    private SQLiteDatabase database;
    private DatabaseHelper db_Helper;
	
    //ContentProviderの初期化
    public boolean onCreate()
    {
        //データベースの生成
    	db_Helper = new DatabaseHelper(getContext());
        database = db_Helper.getWritableDatabase();
        
        return (database != null);
    }

    //データベースのquery命令
    public Cursor query( Uri uri, String[] columns, String selection, String[] selectionArgs, String sortOrder)
    {
        return database.query(DATABASE_TABLE, columns, selection, selectionArgs, null, null, null);
    }
    
    //データベースのupdate命令
    public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs)
    {
    	//database.update(DATABASE_TABLE, values, null, null);
        database.insert(DATABASE_TABLE, "", values);
        
        return 1;
    }    
   
    //DatabaseHelperの定義
    public class DatabaseHelper extends SQLiteOpenHelper
    {
    	public DatabaseHelper(Context context)  //DatabaseHelperのコンストラクタ
    	{
    	   super(context, DATABASE_NAME, null, DATABASE_VERSION);
    	}

    	//データベースの生成
    	public void onCreate(SQLiteDatabase database)
    	{
    	   //database.execSQL("create table if not exists data_table1 " + " (id integer primary key autoincrement,column1 text)");
    	   database.execSQL("create table if not exists " +  DATABASE_TABLE + " (id integer primary key autoincrement," + DATABASE_COLUMN + " text )");
    	}

    	//データベースのUpgrade
    	public void onUpgrade(SQLiteDatabase database, int oldVersion, int newVersion)
    	{
    		//database.execSQL("drop table if exists data_table1");
    		database.execSQL("drop table if exists " + DATABASE_TABLE);
    	    onCreate(database);
    	}
    }
    
    public Uri insert(Uri uri, ContentValues values)  //データベースのinsert命令(未使用)
    {
        return null;
    }
    
    //データベースのdelete命令(未使用)
    public int delete(Uri uri, String selection, String[] selectionArgs)
    {
        return 0;
    }
    
    public String getType(Uri uri)  //Typeの取得(未使用)
    {
        return null;
    }
}
