package com.sample.amdroid.sqlite_test3;

import android.app.Activity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Button;
import android.view.View.OnClickListener;
import android.widget.TextView;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.LinearLayout;
import android.database.Cursor;
import android.content.ContentValues;
import android.net.Uri;
import android.widget.Toast;

public class SQLite_Test3 extends Activity  implements OnClickListener{
    /** Called when the activity is first created. */

    private final int WRAP_CONTENT = ViewGroup.LayoutParams.WRAP_CONTENT;
    private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
	private LinearLayout layout;

    private EditText dataIn_Edit1; //EditText
    private TextView show_TextView1; //TextView

    private Button   Write_Button; //書き込みボタン
    private Button   Read_Button; //読み込みボタン

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        dataIn_Edit1 = new EditText(this);  //データの入力用のEditTextの生成
        dataIn_Edit1.setText("書き込むDataの入力",EditText.BufferType.NORMAL);
        layout.addView(dataIn_Edit1, new LinearLayout.LayoutParams(MP, WRAP_CONTENT));

        Write_Button = new Button(this);  //書き込みボタンの生成
        Write_Button.setTextColor(Color.RED);
        Write_Button.setTextSize(30);
        Write_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Write_Button.setText("Write");
        Write_Button.setOnClickListener(this);
        layout.addView(Write_Button, new LinearLayout.LayoutParams(WRAP_CONTENT, WRAP_CONTENT));

        Read_Button = new Button(this);   //読み込みボタンの生成
        Read_Button.setTextColor(Color.BLUE);
        Read_Button.setTextSize(30);
        Read_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Read_Button.setText("Read");
        Read_Button.setOnClickListener(this);//(2)
        layout.addView(Read_Button, new LinearLayout.LayoutParams(WRAP_CONTENT, WRAP_CONTENT));

        show_TextView1 = new EditText(this);  //データの表示用のテキストビューの生成
        show_TextView1.setTextColor(Color.RED);
        show_TextView1.setTextSize(20);
        show_TextView1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        show_TextView1.setText("データの表示領域",EditText.BufferType.NORMAL);
        layout.addView(show_TextView1, new LinearLayout.LayoutParams(MP, WRAP_CONTENT));
    }

    public void onClick(View v)
    {
        if (v == Write_Button)
        {
        	try{
                 insert_Data();  //データの書き込み
        	}catch(Exception e)
            {
        		Toast.makeText(getApplicationContext(), "データの書き込みエラーが発生しました！",Toast.LENGTH_SHORT).show();
            }

        }else if (v == Read_Button)
        {
        	try{
                 show_Data();  //データの表示
        	}
             catch(Exception e)
            {
            	 Toast.makeText(getApplicationContext(), "データの表示エラーが発生しました！",Toast.LENGTH_SHORT).show();
            }
        }
    }

    public void insert_Data()
    {
    	//ContentProviderへのURI
        Uri uri = Uri.parse("content://com.sample.amdroid.sqlite_contentprovider1/");

    	String column1 = dataIn_Edit1.getText().toString();

    	ContentValues values = new ContentValues();

    	values.put("column1", column1);  //カラム名、値(String)
    	this.getContentResolver().update(uri, values, null, null);
    }

    public void show_Data() throws Exception
    {
      try{
      	  //ContentProviderへのURI
          Uri uri = Uri.parse("content://com.sample.amdroid.sqlite_contentprovider1/");

    	  StringBuffer string_buff = new StringBuffer();

          Cursor cursor = this.getContentResolver().query(uri, new String[]{"id", "column1"}, null, null, null);

    	while (cursor.moveToNext())
    	{
    		string_buff.append(cursor.getInt(0));
    		string_buff.append("：");
    		string_buff.append(cursor.getString(1)+ "\n");
    		//string_buff.append(System.getProperty("line.separator"));
    	}

    	cursor.close();

       	show_TextView1.setText(string_buff.toString());

      }catch (Exception e)
      {
    	  show_TextView1.setText(e.toString()); //エラーの表示！
      }
    }
}