package com.sample.android.service_test1;

import android.app.Service;
import android.content.Intent;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.IBinder;
import android.widget.Toast;

public class Music_Service1 extends Service{

	//メディアプレーヤー
	private MediaPlayer media_player1;

	@Override
	public void onCreate() {
		super.onCreate();

		//SDカード内の音声ファイルを読むとき
		Uri.Builder builder = new Uri.Builder();
		builder.path("/sdcard/sample1.mp3");
		builder.scheme("file");
		//player1 = MediaPlayer.create(this, builder.build());

		media_player1 = MediaPlayer.create(this, R.raw.my_music1);
	}

	//音楽の再生開始
	public void onStart(Intent intent, int startId)
	{
		try{
			media_player1.start();  //音楽の再生開始

			media_player1.setLooping(true);   //音楽のエンドレス再生

		     Toast.makeText(getApplicationContext(), "サウンドの再生を開始しました！",Toast.LENGTH_SHORT).show();
        }catch (Exception e) {
        	 Toast.makeText(getApplicationContext(),e.toString(),Toast.LENGTH_SHORT).show();
        }
	}

	//音楽の停止
	public void onDestroy()
	{
		try{
			media_player1.stop();  //再生を停止する

			media_player1.release();  //リソースを解放する
			media_player1= null;

		     Toast.makeText(getApplicationContext(), "サウンドの再生を停止しました！",Toast.LENGTH_SHORT).show();
		 }catch (Exception e) {
	         Toast.makeText(getApplicationContext(),e.toString(),Toast.LENGTH_SHORT).show();
	     }
	}

	public IBinder onBind(Intent intent)  //バインド
	{
		return null;  //使用しない
	}
}
