package com.sample.android.slot_machine7;

import android.app.Activity;
import android.os.Bundle;
import android.content.res.Resources;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Rect;
import android.graphics.Canvas;
import android.graphics.Color;
import android.view.SurfaceView;
import android.view.SurfaceHolder;
import android.view.MotionEvent;

public class Slot_Machine7 extends Activity {
    /** Called when the activity is first created. */

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        setContentView(new Slot_Machine_View7(this));
    }

    public class Slot_Machine_View7 extends SurfaceView implements SurfaceHolder.Callback,Runnable
    {
    		private SurfaceHolder  holder;
        	private Bitmap  soto_waku1,bar1,bar2,bar3,btn1,btn2,btn3,start_btn1,slot_title1;

            private Thread  myThread;

            private Canvas on_Canvas;

            private int start_btn_x = 0, start_btn_y = 0, stop_btn_x1 = 0, stop_btn_x2 = 0, stop_btn_x3 = 0, stop_btn_y = 0;
            private int compo_x = 0, compo_y = 0;

            private int start_btn_width = 0;   //ボタンの幅
            private int start_btn_height = 0;  //ボタンの高さ
            private int stop_btn_width = 0;
            private int stop_btn_height = 0;

            private int y1 = getHeight()/2 + 130;  //スロットの初期「Y座標」位置
            private int y2 = getHeight()/2;
            private int y3 = getHeight()/2;   // + 260;

            private int dy[] = { 0, 0, 0 }; //加速度用

            private int back_Width, back_Height;

            private Rect source1, destination1;
            private int touch_Action = -999; //タッチアクション用

        	private boolean change_Flag = true;

           //コンストラクタ
            public Slot_Machine_View7(Context context)
            {
                super(context);

                //画像の読み込み
                Resources r =getResources();

                soto_waku1 = BitmapFactory.decodeResource(r,R.drawable.slot_back1);
                bar1 = BitmapFactory.decodeResource(r,R.drawable.bar1);
                bar2 = BitmapFactory.decodeResource(r,R.drawable.bar2);
                bar3 = BitmapFactory.decodeResource(r,R.drawable.bar3);

                slot_title1 = BitmapFactory.decodeResource(r,R.drawable.slot_title1);
                btn1 = BitmapFactory.decodeResource(r,R.drawable.btn1);
                btn2 = BitmapFactory.decodeResource(r,R.drawable.btn2);
                btn3 = BitmapFactory.decodeResource(r,R.drawable.btn3);
                start_btn1 = BitmapFactory.decodeResource(r,R.drawable.start_btn1);

                holder = getHolder();  //「SurfaceHolder」を取得する
                holder.addCallback(this);  //「SurfaceHolder」にコールバックを設定して、コールバック内で描画を行う！
                holder.setFixedSize(getWidth(), getHeight());

                setFocusable(true);  //フォーカスの設定
            }

            //タッチイベントの処理
            public boolean onTouchEvent(MotionEvent event)
            {
                //StartボタンとStopボタンのクリック
            	touch_Action = event.getAction();

            	if(touch_Action == MotionEvent.ACTION_DOWN)
       	        {
                    int touch_x = (int)event.getX();
                    int touch_y = (int)event.getY();

            		if(touch_Action == MotionEvent.ACTION_DOWN)
            		{
                   		if(change_Flag == true)
                		{
                		   myThread = new Thread(this);
                		   myThread.start();  //スレッドのスタート！

                		   change_Flag = false;
                		}

            			//Startボタン
            			if(start_btn_x <= touch_x && touch_x < (start_btn_x + start_btn_width) && start_btn_y <= touch_y && touch_y < (start_btn_y + start_btn_height))
            			{
                            for (int i = 0; i < 3; i++)
                            {
                                //Y軸の上方向への加速量
                                dy[i] = -(int)(Math.random() * 3 )-1 -10;  //-(int)(Math.random() * 3 )-1 -10
                            }

                 		    myThread = new Thread(this);
                		    myThread.start();  //スレッドのスタート！
            			}

            			//Stop1ボタン
            			if(stop_btn_x1 <= touch_x && touch_x < (stop_btn_x1 + stop_btn_width) && stop_btn_y <= touch_y && touch_y < (stop_btn_y + stop_btn_height))
            			{
            				dy[0] = 0;  //加速度分を「0」にして、停止させる！
            			}

            			//Stop2ボタン
            			if(stop_btn_x2 <= touch_x && touch_x < (stop_btn_x2 + stop_btn_width) && stop_btn_y <= touch_y && touch_y < (stop_btn_y + stop_btn_height))
            			{
            				dy[1] = 0;  //加速度分を「0」にして、停止させる！
            			}

            			//Stop3ボタン
            			if(stop_btn_x3 <= touch_x && touch_x < (stop_btn_x3 + stop_btn_width) && stop_btn_y <= touch_y && touch_y < (stop_btn_y + stop_btn_height))
            			{
            				dy[2] = 0;  //加速度分を「0」にして、停止させる！
            			}
            		}
       	        }

        	    return true;
            }

            public void run()
            {
                back_Width = soto_waku1.getWidth();  //外枠の大きさの取得
                back_Height = soto_waku1.getHeight();

                source1 = new Rect(0,0,back_Width, back_Height);  //元の写真の大きさを取得する！
                destination1 = new Rect(0,0,getWidth(), getHeight());  //表示端末の画面の大きさを取得する！

                start_btn_width  = start_btn1.getWidth();   //ボタンの幅の取得
                start_btn_height = start_btn1.getHeight();  //ボタンの高さの取得

                stop_btn_width  = btn1.getWidth();
                stop_btn_height = btn1.getHeight();

                start_btn_x = 115; start_btn_y = getHeight()/2 + 15 + 40;
        		stop_btn_x1 = 70;  stop_btn_x2 = 135; stop_btn_x3 = 200;
        		stop_btn_y = getHeight()/2 + 15;

            	compo_y =  getHeight()/2 + 15;

                while (myThread != null)
                {
                    on_Canvas = holder.lockCanvas(); //Canvasを取得する
                    on_Canvas.drawColor(Color.GREEN);  //窓枠の背景色

                    y1 = y1 + dy[0];
                    y2 = y2 + dy[1];
                    y3 = y3 + dy[2];

                   on_Canvas.drawBitmap(bar1, compo_x + 60,  y1, null);
                   on_Canvas.drawBitmap(bar2, compo_x + 125, y2, null);
                   on_Canvas.drawBitmap(bar3, compo_x + 190, y3, null);

                   on_Canvas.drawBitmap(soto_waku1, source1, destination1, null);  //背景の窓のある画
                   on_Canvas.drawBitmap(slot_title1, compo_x + 10, 30, null);  //タイトル画像

                   on_Canvas.drawBitmap(btn1, compo_x +  60 + 10, compo_y, null);  //Stopボタン
                   on_Canvas.drawBitmap(btn2, compo_x + 125 + 10, compo_y, null);  //Stopボタン
                   on_Canvas.drawBitmap(btn3, compo_x + 190 + 10, compo_y, null);  //Stopボタン

                   on_Canvas.drawBitmap(start_btn1, compo_x + 125 - 10, compo_y + 40, null);  //Startボタン

                    holder.unlockCanvasAndPost(on_Canvas);  //描画を完了する

                    try{
                    	Thread.sleep(150);  //try{}catch{}が必要！
                    }catch(Exception e){
                    }

                    if(y1 <= -780/10 -5) y1 = getHeight()/2 - 65 + 10;

                    if(y2 <= -780/10) y2 = getHeight()/2 - 65;

                    if(y3 <= -780/10) y3 = getHeight()/2 - 65;

                } //while
            } //run

            public void surfaceCreated(SurfaceHolder  holder)
            {
            	myThread = new Thread(this);
            	myThread.start();  //スレッドのスタート！
            }

            public void surfaceDestroyed(SurfaceHolder  holder)
            {
                //myThread = null;
            }

            public void surfaceChanged(SurfaceHolder holder, int format, int w, int h)
            {
            	//特別な処理はなし！
            }
        } //class
}