package com.sample.android.sound_play_test3;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.media.MediaPlayer;
import android.view.Gravity;
import android.view.View;   
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;

public class Sound_Play_Test3 extends Activity implements View.OnClickListener, MediaPlayer.OnCompletionListener{
    /** Called when the activity is first created. */
    private final int WRAP_CONTENT = ViewGroup.LayoutParams.WRAP_CONTENT;
	private LinearLayout layout;
	
	private MediaPlayer media_Player = null;
	
	private Button Play_Button;
	private Button Pause_Button;
	private Button Stop_Button;
	  
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        layout = new LinearLayout(this);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);
        
        Play_Button = new Button(this);  //Playボタン
        Play_Button.setTextColor(Color.RED);
        Play_Button.setTextSize(30);
        Play_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Play_Button.setText("Play");
        Play_Button.setOnClickListener(this);
        layout.addView(Play_Button, new LinearLayout.LayoutParams(WRAP_CONTENT, WRAP_CONTENT));
   //
        Pause_Button = new Button(this);  //Pauseボタン
        Pause_Button.setTextColor(Color.YELLOW);
        Pause_Button.setTextSize(30);
        Pause_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Pause_Button.setText("Pause");
        Pause_Button.setOnClickListener(this);
        layout.addView(Pause_Button,new LinearLayout.LayoutParams(WRAP_CONTENT, WRAP_CONTENT));
         
        Stop_Button = new Button(this);  //Stopボタン
        Stop_Button.setTextColor(Color.BLUE);
        Stop_Button.setTextSize(30);
        Stop_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Stop_Button.setText("Stop");
        Stop_Button.setOnClickListener(this);
        layout.addView(Stop_Button, new LinearLayout.LayoutParams(WRAP_CONTENT, WRAP_CONTENT));
        
        media_Player = MediaPlayer.create(this, R.raw.song1);
        media_Player.setLooping(true);  //ループ再生の設定
    }
    
    public void onClick(View v)
    {   
        if (v == Play_Button)  //Playボタン
        {   
            //if(!media_Player.isPlaying())
            if( media_Player != null)
            {
                media_Player.start();  //MediaPlayerの再生のStart
             
            }else
            {
        	   media_Player = MediaPlayer.create(this, R.raw.song1);
        	   media_Player.setLooping(true);  //サウンドのループ再生
               media_Player.seekTo(0);  //サウンドの再生位置の設定「ミリ秒」
        	   media_Player.start();  //サウンドの再生のStart
               //サウンドの再生完了リスナーの指定
               media_Player.setOnCompletionListener(this);  //サウンド再生の終了時に「onCompletion()」を呼ぶ
            }
          
        }else if(v == Pause_Button)  //Pauseボタン
        {   
        	if( media_Player != null)
        	{
               media_Player.pause();  //MediaPlayerの一時停止
        	}
        	else
        	{ return; }
        }   
        else if(v == Stop_Button)    //Stopボタン
        {   
        	if(media_Player == null)
        	{ 
        		return; 
        	}else
            //if(media_Player.isPlaying())  //参考
        	//if(media_Player == null)
            {
                media_Player.stop();  //MediaPlayerの停止
                media_Player.setOnCompletionListener(null);  //サウンド再生の終了時に「onCompletion()」を呼ぶ
                media_Player.release();    //サウンド用のメモリの開放
                media_Player = null;
              
                try{
                      media_Player.prepare();  //MediaPlayerの再生の準備
                }
                catch (Exception e) {} 
          }
        } 
    }
    
    //サウンド再生の終了時に呼ばれる
    public void onCompletion(MediaPlayer mediaPlayer)
    {
    	media_Player = null;
    }
}