package com.sample.android.sound_record_mike1;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.LinearLayout;
import android.media.MediaRecorder;
import android.os.Environment;
import android.widget.Toast;

public class Sound_Record_Mike1 extends Activity implements View.OnClickListener {
    /** Called when the activity is first created. */
	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;

	private LinearLayout layout;

	private Button   button1;
	private Button   button2;
	private TextView text1;

	private MediaRecorder media_recorder;  //MediaRecorder

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.WHITE);
        text1.setTextSize(20);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("マイクから音声の録音をします！\n");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));
        
        button1 = new Button(this);  //録音Starボタンの生成
        button1.setTextColor(Color.RED);
        button1.setTextSize(18);
        button1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button1.setText("録音Start");
        button1.setOnClickListener(this);
        button1.setGravity(Gravity.CENTER);
        layout.addView(button1, new LinearLayout.LayoutParams(WC, WC));

        button2 = new Button(this);  //録音Sopボタンの生成
        button2.setTextColor(Color.BLUE);
        button2.setTextSize(20);
        button2.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button2.setText("録音Sop");
        button2.setOnClickListener(this);
        button2.setGravity(Gravity.CENTER);
        layout.addView(button2, new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        if(v == button1)  //Start
        {
        	try
        	{
        		String status = Environment.getExternalStorageState();
        		
        		if (status.equals(Environment.MEDIA_MOUNTED))
        		{
        			Toast.makeText(getApplicationContext(), "SDカードOK！",Toast.LENGTH_SHORT).show();
        			 mike_Record_Start();
        		}
        		else{
        		     Toast.makeText(getApplicationContext(), "SDカードが装着されていません！",Toast.LENGTH_SHORT).show();
        		     //return ;
        		}

        	}catch(Exception e)
            {
        		Toast.makeText(getApplicationContext(), "呼び出しエラーが発生しました！",Toast.LENGTH_SHORT).show();
        		Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
            }
        }else if(v == button2) //Stop
        {
        	mike_Record_Stop();
        }
    }

    public void mike_Record_Start()
    {
    	text1.setText("・・・ 録 音 中 ・・・！\n");

        try{
	        media_recorder = new MediaRecorder(); //MediaRecorderのオブジェクトの生成

	        media_recorder.setAudioSource(MediaRecorder.AudioSource.MIC); //録音ソースにMICを指定

	        media_recorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP); //出力フォーマットに「3GP」を指定

	        media_recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB); //AudioEncoderに「AMR_NB」を指定

	        //外部Strageの任意の「PATH情報」を保持したFileオブジェクトを取得(SDカードのディレクトリ)
	        File sd_dir = Environment.getExternalStorageDirectory();

	        //Fileオブジェクトを生成  File(PATH名を表すFileオブジェクト, ファイル または ディレクトリ名)
	        File dir_obj = new File(sd_dir, "Sound_Record_Mike1");

	        //SDカードのディレクトリ「 sd_dir」を作成//
	        if (!dir_obj.exists()) dir_obj.mkdir();

	    	//録音の日の「年月日時分秒」を、ファイル名に使用するとき
	    	String date = new SimpleDateFormat("yyyyMMdd_hh_mmss").format(new Date()); //20110224_
	    	String file_name = "sound_" + date + ".3gp";

	    	//基準の日からの「積算ミリ秒」をファイル名にするとき
	        //String file_name = sound_" + System.currentTimeMillis() + ".3gp";  //ファイル名

	        //SDカードへの出力ファイルの絶対パスを取得
	        String path = new File(dir_obj, file_name).getAbsolutePath();
	        media_recorder.setOutputFile(path);  //SDカードへの出力先ファイルの「PATH」を指定

	        //録音
            media_recorder.prepare();  //録音の準備
            media_recorder.start();  //録音のスタート！

         }catch(IOException e){
        	 Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
         }catch(IllegalStateException e){
        	 Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
         }
    }

    public void mike_Record_Stop()
    {
        text1.setText("録 音  の 停 止 ！\n");

    	try
    	{
           media_recorder.stop();  //録音の停止
           media_recorder.release();  //MediaRecorderの解放

    	}catch(Exception e)
        {
    	   Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
        }
    }
}