package com.sample.amdroid.sqlite1;
import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Button;
import android.widget.TextView;
import android.graphics.Color;
import android.graphics.Typeface;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.Cursor;
import android.content.ContentValues;
import android.content.Context;
import android.widget.Toast;

public class Sqlite1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
	private LinearLayout layout;

	private final static int DATABASE_VERSION  = 1;
	private final static String DATABASE_NAME = "test1.db";   //Database名
	private final static String DATABASE_TABLE = "data_table1";   //Table名
	private final static String DATABASE_COLUMN = "column1";   //Column名

    private EditText dataIn_Edit1; //In_EditText

    private TextView show_TextView1; //Show_TextView

    private Button   Write_Button; //書き込みボタン
    private Button   Read_Button; //読み込みボタン
    
    private SQLiteDatabase database_obj;  //DataBaseのオブジェクトの取得
    private Database_Helper db_Helper;  //自作のDataBase_Helperクラスのオブジェクトの取得
    private StringBuffer string_buff = null;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);//中央寄せ
        setContentView(layout);
        
        dataIn_Edit1 = new EditText(this);  //データの入力用のEditTextの生成
        dataIn_Edit1.setText("書き込むDataの入力",EditText.BufferType.NORMAL);
        layout.addView(dataIn_Edit1, new LinearLayout.LayoutParams(MP, WC));
        
        Write_Button = new Button(this);  //書き込みボタンの生成
        Write_Button.setTextColor(Color.RED);
        Write_Button.setTextSize(30);
        Write_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Write_Button.setText("Write");
        Write_Button.setOnClickListener(this);
        layout.addView(Write_Button, new LinearLayout.LayoutParams(WC, WC));
         
        Read_Button = new Button(this);  //読み込みボタンの生成
        Read_Button.setTextColor(Color.BLUE);
        Read_Button.setTextSize(30);
        Read_Button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        Read_Button.setText("Read");
        Read_Button.setOnClickListener(this);
        layout.addView(Read_Button, new LinearLayout.LayoutParams(WC, WC));
       
        show_TextView1 = new EditText(this);  //データの表示用
        show_TextView1.setTextColor(Color.RED);
        show_TextView1.setTextSize(20);
        show_TextView1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        show_TextView1.setText("データの表示領域",EditText.BufferType.NORMAL);
        layout.addView(show_TextView1, new LinearLayout.LayoutParams(MP, WC));

        db_Helper = new Database_Helper(this);  //自作のDataBase_Helperクラスのオブジェクト
    }

    public void onClick(View v)
    {
        if (v == Write_Button)
        {
        	try{
                 insert_Data();  //データの書き込み用の関数
        	}catch(Exception e)
            {
        		Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
            }

        }else if (v == Read_Button)
        {
        	try{
                 show_Data();  //データの読み込み用の関数
        	}
             catch(Exception e)
            {
            	 Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
            }
        }
    }

    public void insert_Data()  //データの書き込み用の関数
    {
    	database_obj = db_Helper.getWritableDatabase();  //データベース・オブジェクトの取得(「読み/書き」可能)

    	String column1 = dataIn_Edit1.getText().toString();  //EditTextのカラムデータを取得

    	ContentValues values_obj = new ContentValues();
    	values_obj.put(DATABASE_COLUMN , column1); //「カラム名」と「値」(String) を設定する！
    	
        //Tableにレコードを挿入する！
    	database_obj.insert("data_table1", null, values_obj); //「table名」「null値」「レコード情報」(ContentValue)
    	database_obj.close();  //データベースをクローズ
    	Toast.makeText(getApplicationContext(), "データを書き込みました！",Toast.LENGTH_SHORT).show();
    }

    public void show_Data() throws Exception
    {
      try{
    	database_obj = db_Helper.getReadableDatabase();;  //データベース・オブジェクトの取得(読み取り専用)
    	string_buff = new StringBuffer();

        //Cursor cursor = database.query("data_table1", new String[]{"id", "column1"}, null, null, null, null, null);
    	//Cursor cursor = database.query(DATABASE_TABLE, new String[] {"id", "column1"}, null, null, null, null, null);
    	Cursor cursor = database_obj.query(DATABASE_TABLE, new String[] {"id", DATABASE_COLUMN }, null, null, null, null, null);

    	while (cursor.moveToNext())
    	{
    		string_buff.append(cursor.getInt(0));  //取得したデータのバッファへの追加
    		string_buff.append("：");
    		//string_buff.append(cursor.getString(1)+ "\n");  //「改行コード」の追加
    		string_buff.append(cursor.getString(1));
    		string_buff.append(System.getProperty("line.separator"));  //改行コードの取得と追加
    	}

    	cursor.close();
    	database_obj.close();
    	
       	show_TextView1.setText(string_buff.toString());  //レコードの表示
       	Toast.makeText(getApplicationContext(), "データを読み込みました！",Toast.LENGTH_SHORT).show();
      }catch (Exception e)
      {
    	  show_TextView1.setText(e.toString());  //エラーの表示
      }
    }

    //DataBaseHelperの定義//
    public class Database_Helper extends SQLiteOpenHelper
    {
    	public Database_Helper(Context context)  //コンストラクタ
    	{
    	   super(context, DATABASE_NAME, null, DATABASE_VERSION);
    	}

    	//Databaseの生成  
    	public void onCreate(SQLiteDatabase database)
    	{
    	   //database.execSQL("create table if not exists data_table1" + "(id integer primary key autoincrement,column1 text)");
    	   database.execSQL("create table if not exists " +  DATABASE_TABLE + " (id integer primary key autoincrement," + DATABASE_COLUMN + " text )");
    	   //「DATABASE_TABLE」と「DATABASE_COLUMN 」の前後の「""」には、「空白」を入れて、命令の文字を分離すること！
    	}

    	//Databaseのアップグレード  
    	public void onUpgrade(SQLiteDatabase database, int oldVersion, int newVersion)
    	{
    		//database.execSQL("drop table if exists data_table1");  //Sqlの実行
    		database.execSQL("drop table if exists " + DATABASE_TABLE);  //「exists 」の最後に「空白」を入れること！
    	   onCreate(database);
    	}
    }
}