package com.sample.android.text_to_speech2;

import java.util.Locale;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.speech.tts.TextToSpeech;
import android.util.Log;
import android.widget.Toast;

public class Text_To_Speech2 extends Activity implements View.OnClickListener,TextToSpeech.OnInitListener{
    /** Called when the activity is first created. */
	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;

	private TextView text1;
	private EditText edit_text1;
	private Button   button1;
	private Button   button2;
	private Button   button3;

	private TextToSpeech text_to_speech;

	final private Float SPEECH_SLOW = 0.5f;
	final private Float SPEECH_NORMAL = 1.0f;
	final private Float SPEECH_FAST = 1.5f;

	final private Float PITCH_LOW = 0.5f;
	final private Float PITCH_NORMAL = 1.0f;
	final private Float PITCH_HIGH = 1.5f;

	private Locale locale;
	private String get_str;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        //layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.WHITE);
        text1.setTextSize(20);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("英語の文章を入力して下さい！\n");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        edit_text1 = new EditText(this);
        edit_text1.setText("This is TEST !", EditText.BufferType.NORMAL);
        layout.addView(edit_text1,new LinearLayout.LayoutParams(MP, WC));

        button1 = new Button(this);  //[遅めの会話速度]ボタンの生成//
        button1.setTextColor(Color.RED);
        //button.setBackgroundColor(Color.rgb(0,0,0));
        button1.setTextSize(18);
        button1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button1.setText("遅めの会話速度");
        button1.setOnClickListener(this);
        button1.setGravity(Gravity.CENTER);
        layout.addView(button1, new LinearLayout.LayoutParams(WC, WC));

        button2 = new Button(this);  //[通常の会話速度]ボタンの生成
        button2.setTextColor(Color.BLUE);
        //button.setBackgroundColor(Color.rgb(0,0,0));
        button2.setTextSize(18);
        button2.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button2.setText("通常の会話速度");
        button2.setOnClickListener(this);
        button2.setGravity(Gravity.CENTER);
        layout.addView(button2, new LinearLayout.LayoutParams(WC, WC));

        button3 = new Button(this);  //[速めの会話速度]ボタンの生成
        button3.setTextColor(Color.YELLOW);
        //button3.setBackgroundColor(Color.rgb(255,255,255));
        button3.setTextSize(18);
        button3.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button3.setText("速めの会話速度");
        button3.setOnClickListener(this);
        button3.setGravity(Gravity.CENTER);
        layout.addView(button3, new LinearLayout.LayoutParams(WC, WC));

        //TextToSpeechオブジェクトの生成
        text_to_speech = new TextToSpeech(this,this);
    }

    public void onInit(int status)
    {
    	if(TextToSpeech.SUCCESS == status)
    	{
	    	 locale = Locale.ENGLISH; //音声合成のロケール「英語」の指定

	    	//指定したロケールが、この携帯端末で使用できるかを調べる
	    	if(text_to_speech.isLanguageAvailable(locale) >= TextToSpeech.LANG_AVAILABLE)
	    	{
	    		text_to_speech.setLanguage(locale);  //音声合成のロケール「英語」の設定
	    	}else
	    	{
	    		Toast.makeText(this, "サポートしていない言語です！",Toast.LENGTH_LONG).show();
	    	    Log.e("", "Error SetLocale");
	    	}
    	}else
    	{
    		Toast.makeText(this, "Text_To_Speechのエラーです！",Toast.LENGTH_LONG).show();
    	        Log.e("", "Error Init");
    	}
    }

    public void onClick(View v)
    {
    	if(button1 == v)  //[遅めの会話速度]ボタン
    	{
  	        //再生速度の設定(遅めの会話速度)
  	        text_to_speech.setSpeechRate(SPEECH_SLOW);

  	        // 再生ピッチ(音の高低)の設定
  	        text_to_speech.setPitch(PITCH_LOW);

  	        call_Speech_Prepare(); //Speechの準備のための自作関数を呼ぶ

    	 }else if(button2 == v)  //[通常の会話速度]ボタン
    	 {
      	     //再生速度の設定(通常の会話速度)
    	     text_to_speech.setSpeechRate(SPEECH_NORMAL);

    	     //再生ピッチの設定
   	         text_to_speech.setPitch(PITCH_NORMAL);

   	         call_Speech_Prepare(); //Speechの準備のための自作関数を呼ぶ

    	}else if(button3 == v)  //[速めの会話速度]ボタン
    	{
      	     //再生速度の設定(速めの会話速度)
   	         text_to_speech.setSpeechRate(SPEECH_FAST);

   	         //再生ピッチの設定
   	         text_to_speech.setPitch(PITCH_HIGH);

   	         call_Speech_Prepare(); //Speechの準備のための自作関数を呼ぶ
    	}
    }

    public void call_Speech_Prepare()  //Speechの準備
    {
    	get_str = edit_text1.getText().toString();

    	if (get_str.length() > 0)
    	{
    		//読み上げ中かの判定
    		if(text_to_speech.isSpeaking())
    		{
    		    //読み上げ中なら止める
    		    text_to_speech.stop();
    		}

    		//読み上げ開始
    		text_to_speech.speak(get_str, TextToSpeech.QUEUE_FLUSH, null);
    	}
    }

    //アプリケーションの終了時に呼ばれる
    protected void onDestroy()
    {
        super.onDestroy();

        //音声合成の終了
        if (text_to_speech != null) text_to_speech.shutdown(); // TextToSpeechのリソースを解放する
    }
}