package com.sample.android.topview_activity1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.Toast;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.content.Intent;

public class SecondView_Activity1 extends Activity implements View.OnClickListener{

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;

	private TextView text1;
	private TextView text2;
	private EditText edit1;
	private Button   button;

	private Intent intent2;

	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
        layout = new LinearLayout(this);

        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.RED);
        text1.setTextSize(18);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("TopAvtivity からのデータ：");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        text2 = new TextView(this);
        text2.setTextColor(Color.YELLOW);
        text2.setTextSize(20);
        text2.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text2.setText("データ：");
        layout.addView(text2, new LinearLayout.LayoutParams(WC, WC));

        //ボタンの生成
        button = new Button(this);
        button.setTextColor(Color.RED);
        button.setTextSize(18);
        button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button.setText("Activity の終了");
        button.setOnClickListener(this);
        button.setGravity(Gravity.CENTER);
        layout.addView(button, new LinearLayout.LayoutParams(WC, WC));

        edit1 = new EditText(this);
        layout.addView(edit1, new LinearLayout.LayoutParams(MP, WC));

        //戻り値の設定
        setResult(Activity.RESULT_CANCELED);

       //呼び出し元の Activity からのパラメータの取得
        String get_str ;

       //IntentオブジェクトからBunddleオブジェクトを取得
	    Bundle extras1 = getIntent().getExtras();

	    if(extras1 != null)
	    {
	       //呼び出し元  Top_Activity からパラメータを取得 (String key)
	       get_str = extras1.getString("get_edit1");
           
	       text2.setText(get_str);  //テキストビューへの表示
	    }
	}

    public void onClick(View v)
	{
	    if (v == button)
	    {
            intent2 = new Intent();  //intent

            //呼び出し元へのIntentパラメータの付加 (String key, String value)
            intent2.putExtra("result", edit1.getText().toString());

            //呼び出し元の Top_Activity に通知するResultコードの設定
            setResult(Activity.RESULT_OK,intent2);

            //アクティビティの終了
            finish();
	    }
	}
}
