package com.sample.android.topview_activity1;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.Toast;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.content.Intent;

public class TopView_Activity1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;

	private TextView text1;
	private EditText edit1;
	private Button   button;
	private TextView text2;

	private Intent intent1;
	private final static int REQUEST_OK = 0;  //REQUEST_CODE ID

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.RED);
        text1.setTextSize(20);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("送信データの入力：");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        edit1 = new EditText(this);
        layout.addView(edit1, new LinearLayout.LayoutParams(MP, WC));

        //ボタンの生成
        button = new Button(this);
        button.setTextColor(Color.RED);
        button.setTextSize(18);
        button.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button.setText("[ Second_Activity1 ] の呼び出し");
        button.setOnClickListener(this);
        button.setGravity(Gravity.CENTER_HORIZONTAL | Gravity.BOTTOM);
        layout.addView(button, new LinearLayout.LayoutParams(WC, WC));

        text2 = new TextView(this);
        text2.setTextColor(Color.GREEN);
        text2.setTextSize(20);
        text2.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text2.setText("インテントからのパラメータ：");
        layout.addView(text2, new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        if (v == button)
        {
        	try
        	{
        		//TextEditに入力したデータの取得
                String edit1_str = edit1.getText().toString();

                //明示的なIntentの生成 (cntext, 呼び出すActivityのクラス)
                intent1 = new Intent(this, com.sample.android.topview_activity1.SecondView_Activity1.class);

                //Intentへのパラメータの付加 (String key, String value)
                intent1.putExtra("get_edit1", edit1_str);

                //指定のActivityの呼び出し(intent, int requestCode)
                startActivityForResult(intent1,REQUEST_OK);

        	}catch(Exception e)
            {
        		Toast.makeText(getApplicationContext(), "呼び出しエラーが発生しました！",Toast.LENGTH_SHORT).show();
            }
        }
    }

    //Second_Activity1 の呼び出し結果の取得
    protected void onActivityResult(int requestCode,int resultCode,Intent intent)
    {
    	String get_result = "";

        if(requestCode==REQUEST_OK && resultCode==RESULT_OK)
        {
            Bundle extras1 = intent.getExtras();  //Bundleオブジェクトの取得
                                                  
            if (extras1 != null) get_result = extras1.getString("result");  //Second_Activityからのパラメータの取得

            //Second_Activityからの受信パラメータのTextViewへの表示
            text2.setText("受信パラメータ： " + get_result);
        }
    }
}