package com.sample.android.video_record1;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.app.Activity;
import android.os.Bundle;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.LinearLayout;
import android.widget.FrameLayout;
import android.media.MediaRecorder;
import android.os.Environment;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.WindowManager;
import android.util.*;
import android.widget.Toast;

public class Video_Record1 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */
	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;

	private LinearLayout layout;
	private FrameLayout frame_layout;

	private Button   button1;
	private Button   button2;
	private TextView text1;

	private MediaRecorder media_recorder;  //メディア・レコーダー
	private SurfaceHolder surface_holder;  //サーフェイス・ホルダー
    private SurfaceView   surface_view;    //プレビューのためのSurfaceView

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        frame_layout = new FrameLayout(this);
        setContentView(frame_layout);

         //フルスクリーン表示にします
        getWindow().addFlags( WindowManager.LayoutParams.FLAG_FULLSCREEN );

        //SurfaceHolder の生成
        surface_view = new SurfaceView(this);
        surface_holder = surface_view.getHolder();
    	//surface_holder.addCallback(this); //

      frame_layout.addView(surface_view, new FrameLayout.LayoutParams(MP, MP));

        //プッシュバッッファの指定
    	surface_holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);

        text1 = new TextView(this);
        text1.setTextColor(Color.WHITE);
        text1.setTextSize(22);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("ビデオの録画をします！\n");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));

        //Startボタンの生成
        button1 = new Button(this);
        button1.setTextColor(Color.RED);
        button1.setTextSize(20);
        button1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button1.setText("録画Start");
        button1.setOnClickListener(this);
        button1.setGravity(Gravity.CENTER);
        layout.addView(button1, new LinearLayout.LayoutParams(WC, WC));

        //Stopボタンの生成
        button2 = new Button(this);
        button2.setTextColor(Color.BLUE);
        button2.setTextSize(20);
        button2.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button2.setText("録画Stop");
        button2.setOnClickListener(this);
        button2.setGravity(Gravity.CENTER);
        layout.addView(button2, new LinearLayout.LayoutParams(WC, WC));

        frame_layout.addView(layout, new FrameLayout.LayoutParams(MP, MP));
    }

    public void onClick(View v)
    {
        if(v == button1)  //Start
        {
        	try
        	{
        	   Toast.makeText(getApplicationContext(), "Record_Start",Toast.LENGTH_SHORT).show();
               video_Record_Start();

        	}catch(Exception e)
            {
        		Toast.makeText(getApplicationContext(), "呼び出しエラーが発生しました！",Toast.LENGTH_SHORT).show();
            }
        }else if(v == button2) //Stop
        {
        	Toast.makeText(getApplicationContext(), "録 画 Stop !!!",Toast.LENGTH_SHORT).show();
        	video_Record_Stop();
        }
    }

    public void video_Record_Start()
    {
    	text1.setText("・・・ 録 画 中 ・・・！\n");

        try{
	        media_recorder = new MediaRecorder(); //メディア・レコーダーのオブジェクトの生成
	        media_recorder.setVideoSource(MediaRecorder.VideoSource.CAMERA);  //録画ソースにカメラを指定

	        //出力フォーマットに「MPEG_4」をセット
	        media_recorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4);

	        //ビデオエンコーダーに「MPEG_4_SP」をセット
	        media_recorder.setVideoEncoder(MediaRecorder.VideoEncoder.MPEG_4_SP);  //DEFAULT  MPEG_4_SP

	        // プレビュー表示に「Surface」をセット
	        media_recorder.setPreviewDisplay(surface_view.getHolder().getSurface());


	        //外部ストレージの任意のパス情報を保持したFileオブジェクトを取得( SDカードのディレクトリ)
	        File sd_dir = Environment.getExternalStorageDirectory();

	        //Fileオブジェクトを生成  File(PATH名を表すFileオブジェクト, ファイル または ディレクトリ名)
	        File dir_obj = new File(sd_dir, "Video_Record1");

	        //ディレクトリを作成( sd_dir )
	        if (!dir_obj.exists()) dir_obj.mkdir();

	    	//録画の日の「年月日時分秒」を、ファイル名に使用するとき
	    	String date = new SimpleDateFormat("yyyyMMdd_hh_mmss").format(new Date()); //20110224_
	    	String file_name = "video_" + date + ".3gp";

	    	// 基準の日からのミリ秒(ms)を使用するとき
	        //String file_name = sound_" + System.currentTimeMillis() + ".3gp"; //ファイル名

	        // 出力ファイルの絶対パスを取得
	        String path = new File(dir_obj, file_name).getAbsolutePath();
	        media_recorder.setOutputFile(path);  //出力先ファイルのパスを指定

	        //録画
            media_recorder.prepare(); //録画の準備
            media_recorder.start();   //録画のスタート！

         }catch(IOException e){
        	 Log.e("Movie：エラー", e.getMessage());
        	 Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
         }catch(IllegalStateException e){
        	 Log.e("Movie：エラー", e.getMessage());
        	 Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
         }
    }

    public void video_Record_Stop()
    {
        text1.setText("録 画  の 停 止 ！\n");

    	try
    	{
           media_recorder.stop();    //録画の停止
           media_recorder.release(); //メディア・レコーダーの解放
           media_recorder.reset(); // オブジェクトをリセット
           media_recorder = null;

    	}catch(Exception e)
        {
    	   Toast.makeText(getApplicationContext(), e.toString(),Toast.LENGTH_SHORT).show();
        }
    }
}