package com.sample.android.voice_recogniton2;

import java.util.ArrayList;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.LinearLayout;
import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.speech.RecognizerIntent;
import android.widget.Toast;

public class Voice_Recogniton2 extends Activity implements View.OnClickListener{
    /** Called when the activity is first created. */

	private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;

	private LinearLayout layout;

	private Button   button1;
	private TextView text1;

	private static final int REQUEST_CODE = 9999;
	//private static final int VOICE_RECOGNITION_REQUEST_CODE = 9999;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.CENTER);  //中央寄せ
        setContentView(layout);

        text1 = new TextView(this);
        text1.setTextColor(Color.WHITE);
        text1.setTextSize(20);
        text1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        text1.setText("音声入力を文字に変換します！\n");
        layout.addView(text1, new LinearLayout.LayoutParams(WC, WC));
        
        button1 = new Button(this);  //ボタンの生成
        button1.setTextColor(Color.RED);
        button1.setTextSize(18);
        button1.setTypeface(Typeface.create(Typeface.SERIF, Typeface.BOLD_ITALIC));
        button1.setText("音声入力 Start");
        button1.setOnClickListener(this);
        button1.setGravity(Gravity.CENTER_HORIZONTAL | Gravity.BOTTOM);
        layout.addView(button1, new LinearLayout.LayoutParams(WC, WC));
    }

    public void onClick(View v)
    {
        try{
            //Recognizerインテントの作成(音声認識ライブラリをインテント経由で使用するため)
            Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH); //ACTION_RECOGNIZE_SPEECH または ACTION_WEB_SEARCH
            
            //音声認識に使う言語モデルを指定
            intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);

            //音声入力時に、画面(プロンプト)に表示する「メッセージ」をセットする
            intent.putExtra(RecognizerIntent.EXTRA_PROMPT, "旅行したい国は、どこですか？");

            //インテントの開始
            startActivityForResult(intent, REQUEST_CODE);

        }catch (ActivityNotFoundException e){

            //このインテントに応答できるアクティビティがインストールされていない場合、エラーを表示する
            Toast.makeText(getApplicationContext() , "アクティビティが見つかりませんでした。 エラー", Toast.LENGTH_LONG).show();
        }
    }

	//Activityの終了時に、呼び出される 
	protected void onActivityResult(int requestCode, int resultCode, Intent data)
	{
        // requestCodeを確認して、自分が発行したIntentの結果であれば処理を行う 
		if(resultCode != RESULT_OK)
		{
			return;  //正しい結果が得られなかったとき
		}else if(requestCode == REQUEST_CODE)
		{
		    String result_string = "";

		    //音声入力の変換結果を格納する文字列リスト //結果はArrayListで返ってくる 
		    ArrayList<String> results = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);

		    for (int i = 0; i< results.size(); i++)
		    {
		        //音声入力の変換文字列が複数ある場合に、文字列を結合する
		    	result_string += (results.get(i) + "\n");
		    }

		     //音声入力の文字への変換結果を表示
		    text1.setText(result_string);
		}

		super.onActivityResult(requestCode, resultCode, data);
	}
}