package com.sample.android.webview_test2;

import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.view.*;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.CookieManager;
import android.webkit.WebViewClient;
import android.widget.Toast;
import android.app.*;
import android.graphics.Bitmap;

public class WebView_Test2 extends Activity {
    /** Called when the activity is first created. */
	
	//「Manifest.xml」で、INTERNETのパーミッションの設定をすること！
    private final int MP = ViewGroup.LayoutParams.MATCH_PARENT;
	private LinearLayout layout;
	
	private WebView web_view;
	private CookieManager cooki_maneger = null; //
	private String login_cookie = "";
    
    private Dialog dialog1 = null;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        
        layout =new LinearLayout(this);
        setContentView(layout);
        
        //wv = (WebView) findViewById(R.id.web_view);  //参考//
        web_view = new WebView(this);
        layout.addView(web_view,new LinearLayout.LayoutParams(MP, MP));

        WebSettings settings = web_view.getSettings(); //WebViewの標準的なデコレーションの「on/off」の設定

        settings.setJavaScriptEnabled(true); //JavaScriptを有効にする
        settings.setSavePassword(false);  //Passwordの保存の有無「JavaScript用」
        settings.setSaveFormData(false);  //DATEの保存の有無「JavaScript用」
        settings.setSupportZoom(false);   //Zoom機能の有無「JavaScript用」

        settings.setBuiltInZoomControls(true);  //「拡大/縮小」ボタンの表示
//
        web_view.loadUrl("http://www.yahoo.co.jp/");  // URLの読みとりを開始する
        //web_view.requestFocus();  //そのインスタンスに、フォーカスを合わせる
        
        //WebViewClientクラスのインスタンスを登録し、特定のイベントをフックする
        web_view.setWebViewClient(new WebViewClient()
        {
        	//ページ読み込み開始時の動作
        	@Override
        	public void onPageStarted(WebView view, String url, Bitmap favicon)
        	{
         	   Toast.makeText(getApplicationContext(), "読み込み中です！",Toast.LENGTH_SHORT).show();
         	   
         	   //HttpClientで得たCookieの情報を、WebViewでも利用できるようにする
         	   cooki_maneger = CookieManager.getInstance();
        	   login_cookie = cooki_maneger.getCookie(url);
        		
        		//ダイアログを作成して表示
        		//dialog1 = new Dialog(view.getContext());
        		//dialog1.setTitle("ただいまローディング中です！");
        		//dialog1.show();
        	}
        	
        	//ページ読み込み終了時の動作
        	@Override
        	public void onPageFinished(WebView view, String url) {
        		
        		Toast.makeText(getApplicationContext(), "読み込みが終了しました！",Toast.LENGTH_SHORT).show();
        		
        		cooki_maneger = CookieManager.getInstance();
        		cooki_maneger.setCookie(url, login_cookie);
        		
        		//ダイアログを削除
        		//dialog1.dismiss();
        		//dialog1 = null;
        	}
        });
    }
}
 